Index: palm/trunk/SOURCE/exchange_horiz.f90
===================================================================
--- palm/trunk/SOURCE/exchange_horiz.f90	(revision 2693)
+++ palm/trunk/SOURCE/exchange_horiz.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file exchange_horiz.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! 3D-Integer exchange on multigrid level (MS)
+! 
+! 2298 2017-06-29 09:28:18Z raasch
 ! sendrecv_in_background related parts removed
 ! 
@@ -266,8 +269,8 @@
 !> @todo Missing subroutine description.
 !------------------------------------------------------------------------------!
- SUBROUTINE exchange_horiz_int( ar, nbgp_local)
+ SUBROUTINE exchange_horiz_int( ar, nys_l, nyn_l, nxl_l, nxr_l, nzt_l, nbgp_local)
 
     USE control_parameters,                                                    &
-        ONLY:  bc_lr, bc_lr_cyc, bc_ns, bc_ns_cyc
+        ONLY:  bc_lr, bc_lr_cyc, bc_ns, bc_ns_cyc, grid_level
                        
     USE indices,                                                               &
@@ -280,9 +283,13 @@
     IMPLICIT NONE
 
-
+    INTEGER(iwp) ::  nxl_l       !< local index bound at current grid level, left side
+    INTEGER(iwp) ::  nxr_l       !< local index bound at current grid level, right side
+    INTEGER(iwp) ::  nyn_l       !< local index bound at current grid level, north side
+    INTEGER(iwp) ::  nys_l       !< local index bound at current grid level, south side
+    INTEGER(iwp) ::  nzt_l       !< local index bound at current grid level, top
     INTEGER(iwp) ::  nbgp_local  !< number of ghost points
     
-    INTEGER(iwp), DIMENSION(nzb:nzt+1,nys-nbgp_local:nyn+nbgp_local,           &
-                        nxl-nbgp_local:nxr+nbgp_local) ::  ar  !< treated array
+    INTEGER(iwp), DIMENSION(nzb:nzt_l+1,nys_l-nbgp_local:nyn_l+nbgp_local,     &
+                            nxl_l-nbgp_local:nxr_l+nbgp_local) ::  ar  !< treated array
 
 
@@ -293,19 +300,21 @@
 !--    within the PE memory
        IF ( bc_lr_cyc )  THEN
-          ar(:,:,nxl-nbgp_local:nxl-1) = ar(:,:,nxr-nbgp_local+1:nxr)
-          ar(:,:,nxr+1:nxr+nbgp_local) = ar(:,:,nxl:nxl+nbgp_local-1)
+          ar(:,:,nxl_l-nbgp_local:nxl_l-1) = ar(:,:,nxr_l-nbgp_local+1:nxr_l)
+          ar(:,:,nxr_l+1:nxr_l+nbgp_local) = ar(:,:,nxl_l:nxl_l+nbgp_local-1)
        ENDIF
     ELSE
 !
 !--    Send left boundary, receive right one (synchronous)
-       CALL MPI_SENDRECV(                                                      &
-           ar(nzb,nys-nbgp_local,nxl),   1, type_yz_int, pleft,  0,            &
-           ar(nzb,nys-nbgp_local,nxr+1), 1, type_yz_int, pright, 0,            &
+       CALL MPI_SENDRECV(                                                          &
+           ar(nzb,nys_l-nbgp_local,nxl_l),   1, type_yz_int(grid_level), pleft,  0,&
+           ar(nzb,nys_l-nbgp_local,nxr_l+1), 1, type_yz_int(grid_level), pright, 0,&
            comm2d, status, ierr )
 !
 !--    Send right boundary, receive left one (synchronous)
-       CALL MPI_SENDRECV(                                                      &
-           ar(nzb,nys-nbgp_local,nxr+1-nbgp_local), 1, type_yz_int, pright, 1, &
-           ar(nzb,nys-nbgp_local,nxl-nbgp_local),   1, type_yz_int, pleft,  1, &
+       CALL MPI_SENDRECV(                                                          &
+           ar(nzb,nys_l-nbgp_local,nxr_l+1-nbgp_local), 1, type_yz_int(grid_level),&
+           pright, 1,                                                              &
+           ar(nzb,nys_l-nbgp_local,nxl_l-nbgp_local),   1, type_yz_int(grid_level),&
+           pleft,  1,                                                              &
            comm2d, status, ierr )
     ENDIF
@@ -317,6 +326,6 @@
 !--    within the PE memory
        IF ( bc_ns_cyc )  THEN
-          ar(:,nys-nbgp_local:nys-1,:) = ar(:,nyn-nbgp_local+1:nyn,:)
-          ar(:,nyn+1:nyn+nbgp_local,:) = ar(:,nys:nys+nbgp_local-1,:)
+          ar(:,nys_l-nbgp_local:nys_l-1,:) = ar(:,nyn_l-nbgp_local+1:nyn_l,:)
+          ar(:,nyn_l+1:nyn_l+nbgp_local,:) = ar(:,nys_l:nys_l+nbgp_local-1,:)
        ENDIF
 
@@ -325,14 +334,14 @@
 !
 !--    Send front boundary, receive rear one (synchronous)
-       CALL MPI_SENDRECV(                                                      &
-           ar(nzb,nys,nxl-nbgp_local),   1, type_xz_int, psouth, 0,            &
-           ar(nzb,nyn+1,nxl-nbgp_local), 1, type_xz_int, pnorth, 0,            &
+       CALL MPI_SENDRECV(                                                          &
+           ar(nzb,nys_l,nxl_l-nbgp_local),   1, type_xz_int(grid_level), psouth, 0,&
+           ar(nzb,nyn_l+1,nxl_l-nbgp_local), 1, type_xz_int(grid_level), pnorth, 0,&
            comm2d, status, ierr )
 !
 !--    Send rear boundary, receive front one (synchronous)
-       CALL MPI_SENDRECV( ar(nzb,nyn-nbgp_local+1,nxl-nbgp_local), 1,          &
-                          type_xz_int, pnorth, 1,                              &
-                          ar(nzb,nys-nbgp_local,nxl-nbgp_local),   1,          &
-                          type_xz_int, psouth, 1,                              &
+       CALL MPI_SENDRECV( ar(nzb,nyn_l-nbgp_local+1,nxl_l-nbgp_local), 1,          &
+                          type_xz_int(grid_level), pnorth, 1,                      &
+                          ar(nzb,nys_l-nbgp_local,nxl_l-nbgp_local),   1,          &
+                          type_xz_int(grid_level), psouth, 1,                      &
                           comm2d, status, ierr )
 
@@ -342,11 +351,11 @@
 
     IF ( bc_lr == 'cyclic' )  THEN
-       ar(:,:,nxl-nbgp_local:nxl-1) = ar(:,:,nxr-nbgp_local+1:nxr)
-       ar(:,:,nxr+1:nxr+nbgp_local) = ar(:,:,nxl:nxl+nbgp_local-1)
+       ar(:,:,nxl_l-nbgp_local:nxl_l-1) = ar(:,:,nxr_l-nbgp_local+1:nxr_l)
+       ar(:,:,nxr_l+1:nxr_l+nbgp_local) = ar(:,:,nxl_l:nxl_l+nbgp_local-1)
     ENDIF
 
     IF ( bc_ns == 'cyclic' )  THEN
-       ar(:,nys-nbgp_local:nys-1,:) = ar(:,nyn-nbgp_local+1:nyn,:)
-       ar(:,nyn+1:nyn+nbgp_local,:) = ar(:,nys:nys+nbgp_local-1,:)
+       ar(:,nys_l-nbgp_local:nys_l-1,:) = ar(:,nyn_l-nbgp_local+1:nyn_l,:)
+       ar(:,nyn_l+1:nyn_l+nbgp_local,:) = ar(:,nys_l:nys_l+nbgp_local-1,:)
     ENDIF
 
Index: palm/trunk/SOURCE/exchange_horiz_2d.f90
===================================================================
--- palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 2693)
+++ palm/trunk/SOURCE/exchange_horiz_2d.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file exchange_horiz_2d.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Forcing implemented (MS)
+! 
+! 2101 2017-01-05 16:42:31Z suehring
 !
 ! 2000 2016-08-20 18:09:15Z knoop
@@ -77,5 +80,7 @@
 
     USE control_parameters,                                                    &
-        ONLY :  bc_lr_cyc, bc_ns_cyc, inflow_l, inflow_n, inflow_r, inflow_s,  &
+        ONLY :  bc_lr_cyc, bc_ns_cyc, force_bound_l, force_bound_n,            &
+                force_bound_r, force_bound_s,                                  &
+                inflow_l, inflow_n, inflow_r, inflow_s,                        &
                 nest_bound_l, nest_bound_n, nest_bound_r, nest_bound_s,        &
                 outflow_l, outflow_n, outflow_r, outflow_s
@@ -175,20 +180,24 @@
 !-- Neumann-conditions at inflow/outflow/nested boundaries
     IF ( nesting_mode /= 'vertical' )  THEN
-       IF ( inflow_l .OR. outflow_l .OR. nest_bound_l )  THEN
+       IF ( inflow_l .OR. outflow_l .OR. nest_bound_l  .OR.  force_bound_l )   &
+       THEN
           DO  i = nbgp, 1, -1
              ar(:,nxl-i) = ar(:,nxl)
           ENDDO
        ENDIF
-       IF ( inflow_r .OR. outflow_r .OR. nest_bound_r )  THEN
+       IF ( inflow_r .OR. outflow_r .OR. nest_bound_r  .OR.  force_bound_r )   &
+       THEN
           DO  i = 1, nbgp
              ar(:,nxr+i) = ar(:,nxr)
           ENDDO
        ENDIF
-       IF ( inflow_s .OR. outflow_s .OR. nest_bound_s )  THEN
+       IF ( inflow_s .OR. outflow_s .OR. nest_bound_s  .OR.  force_bound_s )   &
+       THEN
           DO  i = nbgp, 1, -1
              ar(nys-i,:) = ar(nys,:)
           ENDDO
        ENDIF
-       IF ( inflow_n .OR. outflow_n .OR. nest_bound_n )  THEN
+       IF ( inflow_n .OR. outflow_n .OR. nest_bound_n  .OR.  force_bound_n )   &
+       THEN
           DO  i = 1, nbgp
              ar(nyn+i,:) = ar(nyn,:)
@@ -214,5 +223,6 @@
 
     USE control_parameters,                                                    &
-        ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, nest_bound_l, nest_bound_n,   &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, force_bound_l, force_bound_n, &
+               force_bound_r, force_bound_s, nest_bound_l, nest_bound_n,       &
                nest_bound_r, nest_bound_s
         
@@ -312,20 +322,20 @@
 !
 !-- Neumann-conditions at inflow/outflow/nested boundaries
-    IF ( nest_bound_l )  THEN
+    IF ( nest_bound_l  .OR.  force_bound_l )  THEN
        DO  i = nbgp_local, 1, -1
          ar(:,nxl_l-i) = ar(:,nxl_l)
        ENDDO
     ENDIF
-    IF ( nest_bound_r )  THEN
+    IF ( nest_bound_r  .OR.  force_bound_r )  THEN
        DO  i = 1, nbgp_local
           ar(:,nxr_l+i) = ar(:,nxr_l)
        ENDDO
     ENDIF
-    IF ( nest_bound_s )  THEN
+    IF ( nest_bound_s  .OR.  force_bound_s )  THEN
        DO  i = nbgp_local, 1, -1
          ar(nys_l-i,:) = ar(nys_l,:)
        ENDDO
     ENDIF
-    IF ( nest_bound_n )  THEN
+    IF ( nest_bound_n  .OR.  force_bound_n )  THEN
        DO  i = 1, nbgp_local
          ar(nyn_l+i,:) = ar(nyn_l,:)
Index: palm/trunk/SOURCE/fft_xy_mod.f90
===================================================================
--- palm/trunk/SOURCE/fft_xy_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/fft_xy_mod.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file fft_xy_mod.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- palm/trunk/SOURCE/flow_statistics.f90	(revision 2693)
+++ palm/trunk/SOURCE/flow_statistics.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file flow_statistics.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Bugfix in evaluation of surface quantities in case different surface types
+! are used (MS)
+! 
+! 2674 2017-12-07 11:49:21Z suehring
 ! Bugfix in output conversion of resolved-scale momentum fluxes in case of 
 ! PW advections scheme.
@@ -288,5 +292,5 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY:  radiation, radiation_scheme, rad_net,                           &
+        ONLY:  radiation, radiation_scheme,                                    &
                rad_lw_in, rad_lw_out, rad_lw_cs_hr, rad_lw_hr,                 &
                rad_sw_in, rad_sw_out, rad_sw_cs_hr, rad_sw_hr
@@ -698,5 +702,6 @@
 !
 !--          2D-arrays (being collected in the last column of sums_l)
-             IF ( surf_def_h(0)%ns >= 1 )  THEN
+             IF ( surf_def_h(0)%end_index(j,i) >=                                 &
+                  surf_def_h(0)%start_index(j,i) )  THEN
                 m = surf_def_h(0)%start_index(j,i)
                 sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +               &
@@ -717,5 +722,5 @@
                 ENDIF
              ENDIF
-             IF ( surf_lsm_h%ns >= 1 )  THEN
+             IF ( surf_lsm_h%end_index(j,i) >= surf_lsm_h%start_index(j,i) )  THEN
                 m = surf_lsm_h%start_index(j,i)
                 sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +               &
@@ -736,6 +741,6 @@
                 ENDIF
              ENDIF
-             IF ( surf_usm_h%ns >= 1 )  THEN
-                m = surf_lsm_h%start_index(j,i)
+             IF ( surf_usm_h%end_index(j,i) >= surf_usm_h%start_index(j,i) )  THEN
+                m = surf_usm_h%start_index(j,i)
                 sums_l(nzb,pr_palm,tn)   = sums_l(nzb,pr_palm,tn) +               &
                                         surf_usm_h%us(m)   * rmask(j,i,sr)
@@ -925,5 +930,6 @@
                    ki = MERGE( -1, 0, l == 0 )
                    IF ( surf_def_h(l)%ns >= 1 )  THEN
-                      DO  m = surf_def_h(l)%start_index(j,i), surf_def_h(l)%end_index(j,i)
+                      DO  m = surf_def_h(l)%start_index(j,i),                  &
+                              surf_def_h(l)%end_index(j,i)
                          k = surf_def_h(l)%k(m)
 
@@ -978,5 +984,6 @@
                    ENDIF
                 ENDDO
-                IF ( surf_lsm_h%ns >= 1 )  THEN
+                IF ( surf_lsm_h%end_index(j,i) >=                              &
+                     surf_lsm_h%start_index(j,i) )  THEN
                    m = surf_lsm_h%start_index(j,i)
                    sums_l(nzb,12,tn) = sums_l(nzb,12,tn) + &
@@ -1028,5 +1035,6 @@
 
                 ENDIF
-                IF ( surf_usm_h%ns >= 1 )  THEN
+                IF ( surf_usm_h%end_index(j,i) >=                              &
+                     surf_usm_h%start_index(j,i) )  THEN
                    m = surf_usm_h%start_index(j,i)
                    sums_l(nzb,12,tn) = sums_l(nzb,12,tn) + &
@@ -1082,17 +1090,20 @@
 
              IF ( .NOT. neutral )  THEN
-                IF ( surf_def_h(0)%ns >= 1 )  THEN
+                IF ( surf_def_h(0)%end_index(j,i) >=                           &
+                     surf_def_h(0)%start_index(j,i) )  THEN
                    m = surf_def_h(0)%start_index(j,i)
-                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) +                      &
+                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) +                   &
                                         surf_def_h(0)%ol(m)  * rmask(j,i,sr) ! L
                 ENDIF
-                IF ( surf_lsm_h%ns >= 1 )  THEN
+                IF ( surf_lsm_h%end_index(j,i) >=                              &
+                     surf_lsm_h%start_index(j,i) )  THEN
                    m = surf_lsm_h%start_index(j,i)
-                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) +                      &
+                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) +                   &
                                         surf_lsm_h%ol(m)  * rmask(j,i,sr) ! L
                 ENDIF
-                IF ( surf_usm_h%ns >= 1 )  THEN
+                IF ( surf_usm_h%end_index(j,i) >=                              &
+                     surf_usm_h%start_index(j,i) )  THEN
                    m = surf_usm_h%start_index(j,i)
-                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) +                      &
+                   sums_l(nzb,112,tn) = sums_l(nzb,112,tn) +                   &
                                         surf_usm_h%ol(m)  * rmask(j,i,sr) ! L
                 ENDIF
@@ -1100,16 +1111,87 @@
 
              IF ( radiation )  THEN
-                sums_l(nzb,99,tn)  = sums_l(nzb,99,tn)  + rad_net(j,i)
-                sums_l(nzb,100,tn)  = sums_l(nzb,100,tn)  + rad_lw_in(nzb,j,i)
-                sums_l(nzb,101,tn)  = sums_l(nzb,101,tn)  + rad_lw_out(nzb,j,i)
-                sums_l(nzb,102,tn)  = sums_l(nzb,102,tn)  + rad_sw_in(nzb,j,i)
-                sums_l(nzb,103,tn)  = sums_l(nzb,103,tn)  + rad_sw_out(nzb,j,i)
+                IF ( surf_def_h(0)%end_index(j,i) >=                           &
+                     surf_def_h(0)%start_index(j,i) )  THEN
+                   m = surf_def_h(0)%start_index(j,i)
+                   sums_l(nzb,99,tn)  = sums_l(nzb,99,tn)  +                   &
+                                        surf_def_h(0)%rad_net(m) * rmask(j,i,sr)
+                   sums_l(nzb,100,tn) = sums_l(nzb,100,tn)  +                  &
+                                        surf_def_h(0)%rad_lw_in(m) * rmask(j,i,sr)
+                   sums_l(nzb,101,tn) = sums_l(nzb,101,tn)  +                  &
+                                        surf_def_h(0)%rad_lw_out(m) * rmask(j,i,sr)
+                   sums_l(nzb,102,tn) = sums_l(nzb,102,tn)  +                  &
+                                        surf_def_h(0)%rad_sw_in(m) * rmask(j,i,sr)
+                   sums_l(nzb,103,tn) = sums_l(nzb,103,tn)  +                  &
+                                        surf_def_h(0)%rad_sw_out(m) * rmask(j,i,sr)
+                ENDIF
+                IF ( surf_lsm_h%end_index(j,i) >=                              &
+                     surf_lsm_h%start_index(j,i) )  THEN
+                   m = surf_lsm_h%start_index(j,i)
+                   sums_l(nzb,99,tn)  = sums_l(nzb,99,tn)  +                   &
+                                        surf_lsm_h%rad_net(m) * rmask(j,i,sr)
+                   sums_l(nzb,100,tn) = sums_l(nzb,100,tn)  +                  &
+                                        surf_lsm_h%rad_lw_in(m) * rmask(j,i,sr)
+                   sums_l(nzb,101,tn) = sums_l(nzb,101,tn)  +                  &
+                                        surf_lsm_h%rad_lw_out(m) * rmask(j,i,sr)
+                   sums_l(nzb,102,tn) = sums_l(nzb,102,tn)  +                  &
+                                        surf_lsm_h%rad_sw_in(m) * rmask(j,i,sr)
+                   sums_l(nzb,103,tn) = sums_l(nzb,103,tn)  +                  &
+                                        surf_lsm_h%rad_sw_out(m) * rmask(j,i,sr)
+                ENDIF
+                IF ( surf_usm_h%end_index(j,i) >=                              &
+                     surf_usm_h%start_index(j,i) )  THEN
+                   m = surf_usm_h%start_index(j,i)
+                   sums_l(nzb,99,tn)  = sums_l(nzb,99,tn)  +                   &
+                                        surf_usm_h%rad_net(m) * rmask(j,i,sr)
+                   sums_l(nzb,100,tn) = sums_l(nzb,100,tn)  +                  &
+                                        surf_usm_h%rad_lw_in(m) * rmask(j,i,sr)
+                   sums_l(nzb,101,tn) = sums_l(nzb,101,tn)  +                  &
+                                        surf_usm_h%rad_lw_out(m) * rmask(j,i,sr)
+                   sums_l(nzb,102,tn) = sums_l(nzb,102,tn)  +                  &
+                                        surf_usm_h%rad_sw_in(m) * rmask(j,i,sr)
+                   sums_l(nzb,103,tn) = sums_l(nzb,103,tn)  +                  &
+                                        surf_usm_h%rad_sw_out(m) * rmask(j,i,sr)
+                ENDIF
 
 #if defined ( __rrtmg )
                 IF ( radiation_scheme == 'rrtmg' )  THEN
-                   sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  + rrtm_aldif(0,j,i)
-                   sums_l(nzb,109,tn)  = sums_l(nzb,109,tn)  + rrtm_aldir(0,j,i)
-                   sums_l(nzb,110,tn)  = sums_l(nzb,110,tn)  + rrtm_asdif(0,j,i)
-                   sums_l(nzb,111,tn)  = sums_l(nzb,111,tn)  + rrtm_asdir(0,j,i)
+
+                   IF ( surf_def_h(0)%end_index(j,i) >=                        &
+                        surf_def_h(0)%start_index(j,i) )  THEN
+                      m = surf_def_h(0)%start_index(j,i)
+                      sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +              &
+                                           surf_def_h(0)%rrtm_aldif(m) * rmask(j,i,sr)
+                      sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +               &
+                                           surf_def_h(0)%rrtm_aldir(m) * rmask(j,i,sr)
+                      sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +               &
+                                           surf_def_h(0)%rrtm_asdif(m) * rmask(j,i,sr)
+                      sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +               &
+                                           surf_def_h(0)%rrtm_asdir(m) * rmask(j,i,sr)
+                   ENDIF
+                   IF ( surf_lsm_h%end_index(j,i) >=                           &
+                        surf_lsm_h%start_index(j,i) )  THEN
+                      m = surf_lsm_h%start_index(j,i)
+                      sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +              &
+                                           surf_lsm_h%rrtm_aldif(m) * rmask(j,i,sr)
+                      sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +               &
+                                           surf_lsm_h%rrtm_aldir(m) * rmask(j,i,sr)
+                      sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +               &
+                                           surf_lsm_h%rrtm_asdif(m) * rmask(j,i,sr)
+                      sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +               &
+                                           surf_lsm_h%rrtm_asdir(m) * rmask(j,i,sr)
+                   ENDIF
+                   IF ( surf_usm_h%end_index(j,i) >=                           &
+                        surf_usm_h%start_index(j,i) )  THEN
+                      m = surf_usm_h%start_index(j,i)
+                      sums_l(nzb,108,tn)  = sums_l(nzb,108,tn)  +              &
+                                           surf_usm_h%rrtm_aldif(m) * rmask(j,i,sr)
+                      sums_l(nzb,109,tn) = sums_l(nzb,109,tn)  +               &
+                                           surf_usm_h%rrtm_aldir(m) * rmask(j,i,sr)
+                      sums_l(nzb,110,tn) = sums_l(nzb,110,tn)  +               &
+                                           surf_usm_h%rrtm_asdif(m) * rmask(j,i,sr)
+                      sums_l(nzb,111,tn) = sums_l(nzb,111,tn)  +               &
+                                           surf_usm_h%rrtm_asdir(m) * rmask(j,i,sr)
+                   ENDIF
+
                 ENDIF
 #endif
Index: palm/trunk/SOURCE/global_min_max.f90
===================================================================
--- palm/trunk/SOURCE/global_min_max.f90	(revision 2693)
+++ palm/trunk/SOURCE/global_min_max.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file global_min_max.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/header.f90
===================================================================
--- palm/trunk/SOURCE/header.f90	(revision 2693)
+++ palm/trunk/SOURCE/header.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file header.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Print information about turbulence closure (TG)
+! Print information about inifor initialization (MS)
+! 
+! 2575 2017-10-24 09:57:58Z maronga
 ! Added output for complex terrain simulations
 ! 
@@ -512,4 +516,6 @@
     ELSEIF ( INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 )  THEN
        run_classification = 'run with 1D - prerun'
+    ELSEIF ( INDEX( initializing_actions, 'inifor' ) /= 0 )  THEN
+       run_classification = 'run initialized with COSMO data'
     ELSEIF ( INDEX( initializing_actions, 'by_user' ) /=0 )  THEN
        run_classification = 'run initialized by user'
@@ -602,4 +608,9 @@
 !-- Numerical schemes
     WRITE ( io, 110 )
+    IF ( rans_mode )  THEN
+       WRITE ( io, 124 )  TRIM( turbulence_closure ), 'RANS'
+    ELSE
+       WRITE ( io, 124 )  TRIM( turbulence_closure ), 'LES'
+    ENDIF
     WRITE ( io, 121 )  TRIM( approximation )
     IF ( psolver(1:7) == 'poisfft' )  THEN
@@ -1962,4 +1973,5 @@
 110 FORMAT (/' Numerical Schemes:'/ &
              ' -----------------'/)
+124 FORMAT (' --> Use the ',A,' turbulence closure (',A,' mode).')
 121 FORMAT (' --> Use the ',A,' approximation for the model equations.')
 111 FORMAT (' --> Solve perturbation pressure via FFT using ',A,' routines')
Index: palm/trunk/SOURCE/inflow_turbulence.f90
===================================================================
--- palm/trunk/SOURCE/inflow_turbulence.f90	(revision 2693)
+++ palm/trunk/SOURCE/inflow_turbulence.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file inflow_turbulence.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
